<?php
// Si mode silencieux vidage automatique du dossier de sortie
if ($CONF['silentORNOT'] == 'erase') {
	@rrmdir($CONF['DIRsortie']);
	@mkdir($CONF['DIRsortie']);
}


### Supprimer les caractres spciaux - dossiers & fichiers ###
// Les caractres '%' et '$' sont systmatiquement chapps, ca gnre des bugs dans les noms de fichiers
function recursive_delete_special_car($dir) {
	$dir = rtrim($dir, '/');
	$dh = opendir($dir);
	
	while (($file = readdir($dh)) !== false ) {
		if ($file !== '.' && $file !== '..') {
			$path = $dir.'/'.$file;
			$new_path = $dir.'/'.delete_special_car($file);
			rename($path, $new_path);
			
			if (is_dir($new_path)) {
				recursive_delete_special_car($new_path);
			}
		}
	}
	closedir($dh);
}

recursive_delete_special_car($CONF['DIRsource']);


### Copyright & Options gnrales des conversion ###
$CONF['copyright'] = utf8_decode($CONF['copyright']);
$CONF['copyCOLOR'] = hex2RGB(nice_hex_color($CONF['copyCOLOR']), true, ' ');

if ($CONF['copyONhd']) {
	$CONF['copyHD'] = '-text_font "'.$CONF['copyFONT'].'" '.$CONF['DIMnormal']*$CONF['copySIZE'].' -text_color '.$CONF['copyCOLOR'].' -text_flag '.$CONF['copyPOS'].' -text_pos 0 0 -text "'.$CONF['copyright'].'"';
} else {
	$CONF['copyHD'] = null;
}

if ($CONF['copyONnormal']) {
	$CONF['copyNormal'] = '-text_font "'.$CONF['copyFONT'].'" '.$CONF['DIMnormal']*$CONF['copySIZE'].' -text_color '.$CONF['copyCOLOR'].' -text_flag '.$CONF['copyPOS'].' -text_pos 0 0 -text "'.$CONF['copyright'].'"';
} else {
	$CONF['copyNormal'] = null;
}

$CONF['convOptions'] = '-ratio -rtype lanczos -rflag decr';
$CONF['JPGexts'] = array('jpg', 'JPG', 'jpeg', 'JPEG'); // extensions admises pour le jpg


### Plugins avant execution ###
foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
	if ($plugin_config['mode'] == 'Before' AND $plugin_config['active']) {
		include('plugins/'.$plugin_id.'/main.php');
	}
}


### Processus principal ###
// Tableau avec les fichiers source
$FilesSource = array();
recursive_readdir($CONF['DIRsource'], 'FilesSource');

// Tableau avec les fichiers de sortie
$FilesSortie = str_replace($CONF['DIRsource'], $CONF['DIRsortie'], $FilesSource);

// Boucle sur tous les fichiers
for ($i=0; $i<count($FilesSource); $i++) {
	// Dcoupe le nom de fichier : dossier/fichier
	preg_match('#(.*)/(.*).([a-z]{3})$#', $FilesSortie[$i], $matches);
	$FileFolder = $matches[1].'/'; // dossier de sortie
	$FileName = $matches[2].'.jpg'; // nom final
	$FileExt = $matches[3]; // extension orginale
		
	// Cre les sous-dossiers de sortie & 'pwg_high' & 'thumbnail'
	if (!file_exists($FileFolder.'pwg_high') AND $CONF['DIRhighORNOT']) {
		mkdir($FileFolder.'pwg_high', 0777, true);
	}
	if (!file_exists($FileFolder.'thumbnail')) {
		mkdir($FileFolder.'thumbnail', 0777, true);
	}
	
	// Informations sur le fichier
	exec('include\nconvert.exe -info "'.$FilesSource[$i].'"', $FileInfos);
	for ($m=0; $m<=5; $m++) {
		unset($FileInfos[$m]);
	}
	foreach ($FileInfos as $key) {
		$a = explode(':', $key);
		$FileInfos[trim($a[0])] = trim($a[1]);
	}
		
	// Plugins pendant l'execution
	foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
		if ($plugin_config['mode'] == 'Process' AND $plugin_config['active']) {
			include('plugins/'.$plugin_id.'/main.php');
		}
	}
	
	// Compresse les fichiers dans le dossier de sortie
	if (!isset($BlockNormal)) { 
		exec('include\nconvert.exe -q '.$CONF['Qnormal'].' -out jpeg -o "'.$FileFolder.$FileName.'" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMnormal'].' '.$CONF['DIMnormal'].' '.$CONF['copyNormal'].' "'.$FilesSource[$i].'"');
	}
	if (!isset($BlockThumbnail)) { 
		exec('include\nconvert.exe -q '.$CONF['Qthumbnail'].' -out jpeg -o "'.$FileFolder.'thumbnail/'.$CONF['prefixe_mini'].$FileName.'" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMthumbnail'].' '.$CONF['DIMthumbnail'].' -rmeta -rexifthumb "'.$FilesSource[$i].'"');
	}
	if (!isset($BlockHigh) AND $CONF['DIRhighORNOT']) {
		if ($CONF['DIMhdORNOT']) {
			exec('include\nconvert.exe -q '.$CONF['Qhd'].' -out jpeg -o "'.$FileFolder.'pwg_high/'.$FileName.'" -dpi '.$CONF['DPI'].' '.$CONF['convOptions'].' -resize '.$CONF['DIMhd'].' '.$CONF['DIMhd'].' '.$CONF['copyHD'].' "'.$FilesSource[$i].'"');
		} else if (!in_array($FileExt, $CONF['JPGexts'])) {
			exec('include\nconvert.exe -q '.$CONF['Qhd'].' -out jpeg -o "'.$FileFolder.'pwg_high/'.$FileName.'" "'.$FilesSource[$i].'"');
		} else {
			copy($FilesSource[$i], $FileFolder.'pwg_high/'.$FileName);
		}
	}
	
	// Rinitialise les bloqueurs
	unset($FileInfos);
	unset($BlockNormal);
	unset($BlockThumbnail);
	unset($BlockHigh);
}


### Supprime les dossiers vides et copie les fichiers index.php ###
$DirsSortie = array();
recursive_readdir($CONF['DIRsortie'], 'DirsSortie', true);

foreach($DirsSortie as $dir) {
	if (is_dir_empty($dir)) {
		rmdir($dir);
	} else if ($CONF['indexORNOT']) {
		copy('includes/index.php', $dir.'/index.php');
	}
}

unset($DirsSortie);


### Plugins aprs execution ###
foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
	if ($plugin_config['mode'] == 'After' AND $plugin_config['active']) {
		include('plugins/'.$plugin_id.'/main.php');
	}
}
?>