<?php
### Gestion des nouveaux plugins ###
// Ajoute la configuration des plugins non-installs au tableau gnral, il faut valider le formulaire pour les installer
$Available_Plugins = glob('plugins/*');
$PLUGIN_ACTION = 'install';

foreach ($Available_Plugins as $plugin) {
	$plugin_id = str_replace('plugins/', '', $plugin); // id du plugin
	if (!array_key_exists($plugin_id, $CONF['Plugins'])) {
		$CONF['Plugins'][$plugin_id] = load_config('plugins/'.$plugin_id.'/config.xml'); // configuration du plugin
		$CONF['Plugins'][$plugin_id]['active'] = false;
		$NewPlugins[$plugin_id] = true;
	}
}


### Gestion des plugins manquants ###
foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
	if (!file_exists('plugins/'.$plugin_id)) {
		$MissingPlugins[$plugin_id] = true;
	}
}


### Formulaire ###
$CONF['copyPOS'] = explode('-', $CONF['copyPOS']);
$CONF['copyCOLOR'] = nice_hex_color($CONF['copyCOLOR']);

$PAGE_CONTENT[0] .= '<form action="index.php?page=setup" method="post">
	<div class="generic config">
		<h2>'.l10n('Configuration').'</h2>
		<ul>
			<li>
				<span class="title">'.l10n('Folders').'</span>
				<table>
					<tr>
						<td>'.l10n('FolderIn').' :</td>
						<td><input type="text" name="DIRsource" value="'.$CONF['DIRsource'].'"/></td>
					</tr>
					<tr>
						<td>'.l10n('FolderOut').' :</td>
						<td><input type="text" name="DIRsortie" value="'.$CONF['DIRsortie'].'"/></td>
					</tr>
				</table>
			</li>
			<li>
				<span class="title">'.l10n('Options').'</span>
				<table>
					<tr>
						<td>'.l10n('silentORNOT').' :</td>
						<td>
							<label><input type="radio" name="silentORNOT" value="erase" '.(($CONF['silentORNOT']=='erase')?'checked="checked"':'').'/> '.l10n('erase').'</label>
							<label><input type="radio" name="silentORNOT" value="block" '.(($CONF['silentORNOT']=='block')?'checked="checked"':'').'/> '.l10n('block').'</label>
							<label><input type="radio" name="silentORNOT" value="pass" '.(($CONF['silentORNOT']=='pass')?'checked="checked"':'').'/> '.l10n('pass').'</label>
						</td>
					</tr>
					<tr>
						<td>'.l10n('DIRhighORNOT').' :</td>
						<td>
							<label><input type="radio" name="DIRhighORNOT" value="true" '.(($CONF['DIRhighORNOT'])?'checked="checked"':'').'/> '.l10n('yes').'</label>
							<label><input type="radio" name="DIRhighORNOT" value="false" '.((!$CONF['DIRhighORNOT'])?'checked="checked"':'').'/> '.l10n('no').'</label>
						</td>
					</tr>
					<tr>
						<td>'.l10n('DIMhdORNOT').' :</td>
						<td>
							<label><input type="radio" name="DIMhdORNOT" value="true" '.(($CONF['DIMhdORNOT'])?'checked="checked"':'').'/> '.l10n('yes').'</label>
							<label><input type="radio" name="DIMhdORNOT" value="false" '.((!$CONF['DIMhdORNOT'])?'checked="checked"':'').'/> '.l10n('no').'</label>
						</td>
					</tr>
					<tr>
						<td>'.l10n('renameORNOT').' :</td>
						<td>
							<label><input type="radio" name="renameORNOT" value="true" '.(($CONF['renameORNOT'])?'checked="checked"':'').'/> '.l10n('yes').'</label>
							<label><input type="radio" name="renameORNOT" value="false" '.((!$CONF['renameORNOT'])?'checked="checked"':'').'/> '.l10n('no').'</label>
						</td>
					</tr>
					<tr>
						<td>'.l10n('indexORNOT').' :</td>
						<td>
							<label><input type="radio" name="indexORNOT" value="true" '.(($CONF['indexORNOT'])?'checked="checked"':'').'/> '.l10n('yes').'</label>
							<label><input type="radio" name="indexORNOT" value="false" '.((!$CONF['indexORNOT'])?'checked="checked"':'').'/> '.l10n('no').'</label>
						</td>
					</tr>
					<tr>
						<td>'.l10n('prefixe_mini').' :</td>
						<td><input type="text" name="prefixe_mini" value="'.$CONF['prefixe_mini'].'" size="8"/></td>
					</tr>
				</table>
			</li>
			<li>
				<span class="title">'.l10n('Sizes and quality').'</span>
				<table>
					<tr>
						<td>'.l10n('DIMhd').' :</td>
						<td><input type="text" name="DIMhd" value="'.$CONF['DIMhd'].'" size="4"/>px</td>
					</tr>
					<tr>
						<td>'.l10n('DIMnormal').' :</td>
						<td><input type="text" name="DIMnormal" value="'.$CONF['DIMnormal'].'" size="3"/>px</td>
					</tr>
					<tr>
						<td>'.l10n('DIMthumbnail').' :</td>
						<td><input type="text" name="DIMthumbnail" value="'.$CONF['DIMthumbnail'].'" size="3"/>px</td>
					</tr>
					<tr>
						<td>'.l10n('Qhd').' :</td>
						<td><input type="text" name="Qhd" value="'.$CONF['Qhd'].'" size="3"/>%</td>
					</tr>
					<tr>
						<td>'.l10n('Qnormal').' :</td>
						<td><input type="text" name="Qnormal" value="'.$CONF['Qnormal'].'" size="3"/>%</td>
					</tr>
					<tr>
						<td>'.l10n('Qthumbnail').' :</td>
						<td><input type="text" name="Qthumbnail" value="'.$CONF['Qthumbnail'].'" size="3"/>%</td>
					</tr>
					<tr>
						<td>'.l10n('DPI').' :</td>
						<td><input type="text" name="DPI" value="'.$CONF['DPI'].'" size="3"/>dpi</td>
					</tr>
				</table>
			</li>
			<li>
				<span class="title">'.l10n('Copyright').'</span>
				<table>
					<tr>
						<td>'.l10n('Content').' :</td>
						<td><input type="text" name="copyright" value="'.$CONF['copyright'].'"/></td>
					</tr>
					<tr>
						<td>'.l10n('copyONhd').' :</td>
						<td>
							<label><input type="radio" name="copyONhd" value="true" '.(($CONF['copyONhd'])?'checked="checked"':'').'/> '.l10n('yes').'</label>
							<label><input type="radio" name="copyONhd" value="false" '.((!$CONF['copyONhd'])?'checked="checked"':'').'/> '.l10n('no').'</label>
						</td>
					</tr>
					<tr>
						<td>'.l10n('copyONnormal').' :</td>
						<td>
							<label><input type="radio" name="copyONnormal" value="true" '.(($CONF['copyONnormal'])?'checked="checked"':'').'/> '.l10n('yes').'</label>
							<label><input type="radio" name="copyONnormal" value="false" '.((!$CONF['copyONnormal'])?'checked="checked"':'').'/> '.l10n('no').'</label>
						</td>
					</tr>
					<tr>
						<td>'.l10n('copyPOS%s', l10n('copyPOSv')).' :</td>
						<td>
							<label><input type="radio" name="copyPOS[0]" value="top" '.(($CONF['copyPOS'][0]=='top')?'checked="checked"':'').'/> '.l10n('top').'</label>
							<label><input type="radio" name="copyPOS[0]" value="center" '.(($CONF['copyPOS'][0]=='center')?'checked="checked"':'').'/> '.l10n('center').'</label>
							<label><input type="radio" name="copyPOS[0]" value="bottom" '.(($CONF['copyPOS'][0]=='bottom')?'checked="checked"':'').'/> '.l10n('bottom').'</label>
						</td>
					</tr>
					<tr>
						<td>'.l10n('copyPOS%s', l10n('copyPOSh')).' :</td>
						<td>
							<label><input type="radio" name="copyPOS[1]" value="left" '.(($CONF['copyPOS'][1]=='left')?'checked="checked"':'').'/> '.l10n('left').'</label>
							<label><input type="radio" name="copyPOS[1]" value="center" '.(($CONF['copyPOS'][1]=='center')?'checked="checked"':'').'/> '.l10n('center').'</label>
							<label><input type="radio" name="copyPOS[1]" value="right" '.(($CONF['copyPOS'][1]=='right')?'checked="checked"':'').'/> '.l10n('right').'</label>
						</td>
					</tr>
					<tr>
						<td>'.l10n('copySIZE').' :</td>
						<td><input type="text" name="copySIZE" value="'.$CONF['copySIZE'].'" size="5"/></td>
					</tr>
					<tr>
						<td>'.l10n('copyCOLOR').' :</td>
						<td><input type="text" name="copyCOLOR" value="'.$CONF['copyCOLOR'].'" size="6" id="colorpicker"/></td>
						<script type="text/javascript">
							$("#colorpicker").ColorPicker({
								onSubmit: function(hsb, hex, rgb, el) { $(el).val(hex); $(el).ColorPickerHide(); },
								onChange: function(hsb, hex, rgb, el) { $("#colorpicker").val(hex); },
								onBeforeShow: function () { $(this).ColorPickerSetColor(this.value); }
							}) .bind("keyup", function(){ $(this).ColorPickerSetColor(this.value); });
						</script>
					</tr>
					<tr>
						<td>'.l10n('copyFONT').' :</td>
						<td><input type="text" name="copyFONT" value="'.$CONF['copyFONT'].'"/></td>
					</tr>
				</table>
			</li>
		</ul>
	</div>

	<div class="generic config">
		<h2>'.l10n('Plugins').'</h2>
		<ul>';
			
			// Affichage des plugins
			$PLUGIN_ACTION = 'edit_config';
			
			foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
				$PAGE_CONTENT[0] .= '<li>
					<div class="plugin-title">
						<span class="title">'.$plugin_config['name'].' :</span>
						<input type="hidden" name="Plugins['.$plugin_id.'][name]" value="'.$plugin_config['name'].'"/>
						<input type="hidden" name="Plugins['.$plugin_id.'][mode]" value="'.$plugin_config['mode'].'"/>';
						
						// Cas spciaux dans le titre (nouveau, manquant)
						if (isset($NewPlugins[$plugin_id])) {
							$PAGE_CONTENT[0] .= ' <b class="new">'.l10n('New !').'</b>';
						} else if (isset($MissingPlugins[$plugin_id])) {
							$PAGE_CONTENT[0] .= ' <b class="miss">'.l10n('Missing !').'</b>';
						}
						
						// Si il est manquant on ne met que la checkbox de suppression, sinon boutons d'activation
						$PAGE_CONTENT[0] .= '<span class="plugin-active">';
							if (isset($MissingPlugins[$plugin_id])) {
								$PAGE_CONTENT[0] .= '<label><input type="checkbox" name="Plugins['.$plugin_id.'][delete]" value="true" checked="checked"/> '.l10n('erase').'</label>';
							} else {
								$PAGE_CONTENT[0] .= '<label><input type="radio" name="Plugins['.$plugin_id.'][active]" value="true" '.(($plugin_config['active'])?'checked="checked"':'').'/> '.l10n('Active').'</label>
								<label><input type="radio" name="Plugins['.$plugin_id.'][active]" value="false" '.((!$plugin_config['active'])?'checked="checked"':'').'/> '.l10n('Inactive').'</label>';
							}
						$PAGE_CONTENT[0] .= '</span>
						
					</div>';
					
					
					// On affiche sa configuration
					if (!isset($MissingPlugins[$plugin_id]) AND file_exists('plugins/'.$plugin_id.'/setup.php')) {
						include('plugins/'.$plugin_id.'/setup.php');
					}
				$PAGE_CONTENT[0] .= '</li>';
			}
			
		$PAGE_CONTENT[0] .= '</ul>
	</div>';
	

	$PAGE_CONTENT[2] .= '<div class="generic link">
		<input type="submit" value="'.l10n('Valid').'"/>
		<input type="reset" value="'.l10n('Reset').'"/>
		<input type="reset" onclick="location.href=\'index.php\'" value="'.l10n('Back').'"/>
	</div>
</form>';
?>