<?php
/***************************************\
|			PHP OPTIMISATEUR			|
|	  Plugin CreateCustomThumbs 1.0		|
\***************************************/

## Différents traitements sur les miniatures : taille fixe & cadre (2 couleurs)
## Dépend de la valeur de $CONF['DIMthumbnail']

// CreateCustomThumbs à la priorité sur ConvertPan
if (isset($CONF['Plugins']['convert_pan']) OR !isset($BlockThumbnail)) { 

	$FileSource = $FilesSource[$i]; // fichier de travail
	$DIMthumbnailV = $CONF['Plugins']['create_custom_thumbs']['DIMthumbnailV']; // Hauteur de l'image
	$FRAMEparams = $CONF['Plugins']['create_custom_thumbs']['FRAMEparams']; // Paramètres du cadre
	
	// Miniature de taille personnalisée
	if ($DIMthumbnailV != 0) {
		$max = max($CONF['DIMthumbnail'], $DIMthumbnailV);

		// on prend la miniature au milieu de l'image
		if ($FileInfos['Height'] >= $FileInfos['Width']) {
			$resize_param = $max.' 0';
			$tmp_x = $max;
			$tmp_y = $max * $FileInfos['Height'] / $FileInfos['Width'];
		} else {
			$resize_param = '0 '.$max;
			$tmp_x = $max * $FileInfos['Width'] / $FileInfos['Height'];
			$tmp_y = $max;
		}
		
		$offset_x = ($tmp_x - $CONF['DIMthumbnail']) / 2;
		$offset_y = ($tmp_y - $DIMthumbnailV) / 2;
		
		exec('files\nconvert.exe -overwrite -q '.$CONF['Qthumbnail'].' -out jpeg -o "'.$FileFolder.'thumbnail/'.$CONF['prefixe_mini'].$FileName.'" -dpi 72 '.$CONF['convOptions'].' -resize '.$resize_param.' -crop '.$offset_x.' '.$offset_y.' '.$CONF['DIMthumbnail'].' '.$DIMthumbnailV.' -rmeta -rexifthumb 	"'.$FileSource.'"');
		
		$BlockThumbnail = true;
		$FileSource = $FileFolder.'thumbnail/'.$CONF['prefixe_mini'].$FileName;
	}

	// Cadre autour de la miniature
	if ($FRAMEparams['size1'] != 0 OR $FRAMEparams['size2'] != 0) {
		// Si la miniature n'a pas encore été générée il faut le faire
		if ($FileSource == $FilesSource[$i]) {
			exec('files\nconvert.exe -q '.$CONF['Qthumbnail'].' -out jpeg -o "'.$FileFolder.'thumbnail/'.$CONF['prefixe_mini'].$FileName.'" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMthumbnail'].' '.$CONF['DIMthumbnail'].' -rmeta -rexifthumb 	"'.$FilesSource[$i].'"');
			$FileSource = $FileFolder.'thumbnail/'.$CONF['prefixe_mini'].$FileName;
		}

		$img = imagecreatefromjpeg($FileSource);
		$x = imagesx($img)-1;
		$y = imagesy($img)-1;
		
		$colors[0] = hex2RGB($FRAMEparams['color1']);
		$colors[1] = hex2RGB($FRAMEparams['color2']);
		$colors[0] = imagecolorallocate($img, $colors[0]['r'], $colors[0]['g'], $colors[0]['b']);
		$colors[1] = imagecolorallocate($img, $colors[1]['r'], $colors[1]['g'], $colors[1]['b']);

		for ($m=0; $m<$FRAMEparams['size1']; $m++) {
			imagerectangle($img, $m, $m, $x-$m, $y-$m, $colors[0]);
		}
		for ($m=$FRAMEparams['size1']; $m<$FRAMEparams['size1']+$FRAMEparams['size2']; $m++) {
			imagerectangle($img, $m, $m, $x-$m, $y-$m, $colors[1]);
		}
		
		imagejpeg($img, $FileFolder.'thumbnail/'.$CONF['prefixe_mini'].$FileName, $CONF['Qthumbnail']);
		imagedestroy($img);
		
		$BlockThumbnail = true;
		$FileSource = $FileFolder.'thumbnail/'.$CONF['prefixe_mini'].$FileName;
	}
}

?>